/*

This file contains my favorite sorting algorithm, Merge Sort.
This algorithm is the best I've seen for sorting large amounts of data.

Example:

var/list/j = list("c","a","b")
j = mergesort(j)

Outputs:
a
b
c

*/


proc
	mergesort(list/j)
		if(j.len <= 1)
			return j
		else
			var
				mid = round(j.len / 2)
				list/left = new/list
				list/right = new/list

			for(var/i = 1 to mid)
				left += j[i]
			for(var/i = mid+1 to j.len)
				right += j[i]

			left = mergesort(left)
			right = mergesort(right)
			return merge(left, right)


	merge(list/left, list/right)
		var/list/result = new/list

		while(left.len > 0 && right.len > 0)
			if(left[1] <= right[1])
				result += left[1]
				left.Cut(1, 2)
			else
				result += right[1]
				right.Cut(1, 2)

		if(left.len > 0)
			result += left
		if(right.len > 0)
			result += right
		return result

